-- Pour générer la base de données PostgreSQL pour le projet Classements Ludiques
CREATE TYPE type_jeu AS ENUM ('duels', 'equipes');
CREATE TYPE type_scores_jeu AS ENUM ('classement', 'scores');


DROP TABLE IF EXISTS R_jeu;
CREATE TABLE R_jeu (
  nom VARCHAR(255) NOT NULL,
  description TEXT NOT NULL,
  slug VARCHAR(255) PRIMARY KEY,
  est_valide BOOLEAN NOT NULL,
  max_joueurs INT,
  min_joueurs INT,
  min_equipes INT,
  max_equipes INT,
  type type_jeu NOT NULL,
  type_scores type_scores_jeu NOT NULL
);

DROP TABLE IF EXISTS R_joueur;
CREATE TABLE R_joueur (
  slug VARCHAR(255) PRIMARY KEY,
  pseudo VARCHAR(100) NOT NULL,
  password TEXT NOT NULL,
  nom VARCHAR(150) NOT NULL,
  prenom VARCHAR(150) NOT NULL,
  email VARCHAR(255) UNIQUE NOT NULL,
  description TEXT NOT NULL,
  avatar BOOLEAN DEFAULT '0'
);

DROP TABLE IF EXISTS R_admin;
CREATE TABLE R_admin (
  identite varchar(255) REFERENCES R_joueur(slug),
  PRIMARY KEY (identite)
  );

DROP TABLE IF EXISTS R_partie;
CREATE TABLE R_partie (
  id SERIAL PRIMARY KEY,
  jeu VARCHAR(255) REFERENCES R_jeu(slug),
  date TIMESTAMP NOT NULL
);

DROP TABLE IF EXISTS R_joueur_partie;
CREATE TABLE R_joueur_partie (
  partie INT REFERENCES R_partie(id),
  joueur VARCHAR(255) REFERENCES R_joueur(slug),
  classement INT NOT NULL,
  score INT NOT NULL,
  score_partie INT,
  PRIMARY KEY (joueur, partie)
);

DROP TABLE IF EXISTS R_joueur_jeu;
CREATE TABLE R_joueur_jeu (
  joueur varchar(255) REFERENCES R_joueur(slug),
  jeu VARCHAR(255) REFERENCES R_jeu(slug),
  score INT,
  classement INT,
  est_jeu_favoris BOOLEAN,
  PRIMARY KEY (joueur, jeu)
);

